/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.decoder;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.vliw.op.MOVT_S;
import ru.ispras.microtesk.model.vliw.mode.F;
import ru.ispras.microtesk.model.api.Immediate;

/**
 * The {@code DecoderMOVT_S} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderMOVT_S extends DecoderItem {
  private static DecoderMOVT_S instance = null;

  public static DecoderMOVT_S get() {
    if (null == instance) {
      instance = new DecoderMOVT_S();
    }
    return instance;
  }

  private DecoderMOVT_S() {
    super(
        32,
        true,
        "01000110000000010000000000010001",
        "11111111111000110000000000111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    F fd = null;
    F fs = null;
    Immediate cc = null;

    if (!matchNextOpc(image, BitVector.valueOf("01000110000", 2, 11))) {
      return null;
    }
    cc = readNextImmediate(image, COND_CODE);

    if (!matchNextOpc(image, BitVector.valueOf("01", 2, 2))) {
      return null;
    }
    fs = (F) readNextPrimitive(image, DecoderF.get());
    if (null == fs) {
      return null;
    }
    fd = (F) readNextPrimitive(image, DecoderF.get());
    if (null == fd) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("010001", 2, 6))) {
      return null;
    }

    return newResult(new MOVT_S(fd, fs, cc));
  }
}
