/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.decoder;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.x86.mode.BIDAM_BX_DI_D8;
import ru.ispras.microtesk.model.api.Immediate;

/**
 * The {@code DecoderBIDAM_BX_DI_D8} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBIDAM_BX_DI_D8 extends DecoderItem {
  private static DecoderBIDAM_BX_DI_D8 instance = null;

  public static DecoderBIDAM_BX_DI_D8 get() {
    if (null == instance) {
      instance = new DecoderBIDAM_BX_DI_D8();
    }
    return instance;
  }

  private DecoderBIDAM_BX_DI_D8() {
    super(
        8,
        true,
        null,
        null
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    Immediate disp = null;
    disp = readNextImmediate(image, SBYTE);

    return newResult(new BIDAM_BX_DI_D8(disp));
  }
}
