/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.TempVars;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class sub_proc_word extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "sub_proc_word",
          sub_proc_word.class,
          null
          );
      addArgument("op1", WORD);
      addArgument("op2", WORD);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate op1 = (Immediate) getArgument("op1", args);
      final Immediate op2 = (Immediate) getArgument("op2", args);

      return new sub_proc_word(op1, op2);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate op1;
  public final Immediate op2;

  public sub_proc_word(final Immediate op1, final Immediate op2) {
    assert WORD.equals(op1.getType());
    assert WORD.equals(op2.getType());
    this.op1 = op1;
    this.op2 = op2;
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.tmpw_res.access().store(Data.zeroExtend(Type.CARD(17), op1.access().load()).subtract(Data.zeroExtend(Type.CARD(17), op2.access().load())));
    pe__.OF.access().store(Data.valueOf(BIT, op1.access().bitField(15, 15).load().equals(op2.access().bitField(15, 15).load()) && !op1.access().bitField(15, 15).load().equals(vars__.tmpw_res.access().bitField(15, 15).load())));
    pe__.CF.access().store(vars__.tmpw_res.access().bitField(16, 16).load());
    pe__.AF.access().store(op1.access().bitField(4, 4).load().not().and(op2.access().bitField(4, 4).load().not()).and(vars__.tmpw_res.access().bitField(4, 4).load()).or(op1.access().bitField(4, 4).load().not().and(op2.access().bitField(4, 4).load()).and(vars__.tmpw_res.access().bitField(4, 4).load().not())).or(op1.access().bitField(4, 4).load().and(op2.access().bitField(4, 4).load().not()).and(vars__.tmpw_res.access().bitField(4, 4).load().not())).or(op1.access().bitField(4, 4).load().and(op2.access().bitField(4, 4).load()).and(vars__.tmpw_res.access().bitField(4, 4).load())));
    pe__.ZF.access().store(Data.valueOf(BIT, vars__.tmpw_res.access().bitField(15, 0).load().equals(Data.valueOf(Type.CARD(16), 0x0))));
    pe__.SF.access().store(Data.valueOf(BIT, vars__.tmpw_res.access().bitField(15, 15).load().equals(Data.valueOf(Type.CARD(1), 0x1))));
  }
}